OGRE: Ogre::RenderSystemCapabilitiesSerializer Class Reference - OGRE Documentation

# Ogre::RenderSystemCapabilitiesSerializer Class Reference

Class for serializing RenderSystemCapabilities to / from a .rendercaps script. More...

`#include <OgreRenderSystemCapabilitiesSerializer.h>`

Inheritance diagram for Ogre::RenderSystemCapabilitiesSerializer:

[legend]

List of all members.

## Public Member Functions
| RenderSystemCapabilitiesSerializer ()
| default constructor
virtual | ~RenderSystemCapabilitiesSerializer ()
| default destructor
void | writeScript (const RenderSystemCapabilities *caps, String name, String filename)
| Writes a RenderSystemCapabilities object to a data stream.
void | parseScript (DataStreamPtr &stream)
| Parses a RenderSystemCapabilities script file passed as a stream.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Types
enum | CapabilityKeywordType { UNDEFINED_CAPABILITY_TYPE = 0, SET_STRING_METHOD, SET_INT_METHOD, SET_BOOL_METHOD, SET_REAL_METHOD, SET_CAPABILITY_ENUM_BOOL, ADD_SHADER_PROFILE_STRING }
enum | ParseAction { PARSE_HEADER, FIND_OPEN_BRACE, COLLECT_LINES }
typedef std::map< String, CapabilityKeywordType > | KeywordTypeMap
typedef void(RenderSystemCapabilities::* | SetStringMethod )(const String &)
typedef std::map< String, SetStringMethod > | SetStringMethodDispatchTable
typedef void(RenderSystemCapabilities::* | SetIntMethod )(ushort)
typedef std::map< String, SetIntMethod > | SetIntMethodDispatchTable
typedef void(RenderSystemCapabilities::* | SetBoolMethod )(bool)
typedef std::map< String, SetBoolMethod > | SetBoolMethodDispatchTable
typedef void(RenderSystemCapabilities::* | SetRealMethod )(Real)
typedef std::map< String, SetRealMethod > | SetRealMethodDispatchTable
typedef std::map< String, Capabilities > | CapabilitiesMap
typedef std::vector< std::pair < String, int > > | CapabilitiesLinesList
## Protected Member Functions
void | addCapabilitiesMapping (String name, Capabilities cap)
void | addKeywordType (String keyword, CapabilityKeywordType type)
CapabilityKeywordType | getKeywordType (const String &keyword) const
void | addSetStringMethod (String keyword, SetStringMethod method)
void | callSetStringMethod (String &keyword, String &val)
void | addSetIntMethod (String keyword, SetIntMethod method)
void | callSetIntMethod (String &keyword, int val)
void | addSetBoolMethod (String keyword, SetBoolMethod method)
void | callSetBoolMethod (String &keyword, bool val)
void | addSetRealMethod (String keyword, SetRealMethod method)
void | callSetRealMethod (String &keyword, Real val)
void | addShaderProfile (String &val)
void | setCapabilityEnumBool (String &name, bool val)
void | initialiaseDispatchTables ()
void | parseCapabilitiesLines (CapabilitiesLinesList &linesList)
void | logParseError (const String &error) const
## Protected Attributes
KeywordTypeMap | mKeywordTypeMap
SetStringMethodDispatchTable | mSetStringMethodDispatchTable
SetIntMethodDispatchTable | mSetIntMethodDispatchTable
SetBoolMethodDispatchTable | mSetBoolMethodDispatchTable
SetRealMethodDispatchTable | mSetRealMethodDispatchTable
CapabilitiesMap | mCapabilitiesMap
int | mCurrentLineNumber
String * | mCurrentLine
DataStreamPtr | mCurrentStream
RenderSystemCapabilities * | mCurrentCapabilities

## Detailed Description

Class for serializing RenderSystemCapabilities to / from a .rendercaps script.

Definition at line 43 of file OgreRenderSystemCapabilitiesSerializer.h.

## Member Typedef Documentation

typedef std::map<String, CapabilityKeywordType> Ogre::RenderSystemCapabilitiesSerializer::KeywordTypeMap`[protected]`

Definition at line 69 of file OgreRenderSystemCapabilitiesSerializer.h.

typedef void(RenderSystemCapabilities::* Ogre::RenderSystemCapabilitiesSerializer::SetStringMethod)(const String &)`[protected]`

typedef std::map<String, SetStringMethod> Ogre::RenderSystemCapabilitiesSerializer::SetStringMethodDispatchTable`[protected]`

Definition at line 74 of file OgreRenderSystemCapabilitiesSerializer.h.

typedef void(RenderSystemCapabilities::* Ogre::RenderSystemCapabilitiesSerializer::SetIntMethod)(ushort)`[protected]`

typedef std::map<String, SetIntMethod> Ogre::RenderSystemCapabilitiesSerializer::SetIntMethodDispatchTable`[protected]`

Definition at line 79 of file OgreRenderSystemCapabilitiesSerializer.h.

typedef void(RenderSystemCapabilities::* Ogre::RenderSystemCapabilitiesSerializer::SetBoolMethod)(bool)`[protected]`

typedef std::map<String, SetBoolMethod> Ogre::RenderSystemCapabilitiesSerializer::SetBoolMethodDispatchTable`[protected]`

Definition at line 84 of file OgreRenderSystemCapabilitiesSerializer.h.

typedef void(RenderSystemCapabilities::* Ogre::RenderSystemCapabilitiesSerializer::SetRealMethod)(Real)`[protected]`

typedef std::map<String, SetRealMethod> Ogre::RenderSystemCapabilitiesSerializer::SetRealMethodDispatchTable`[protected]`

Definition at line 89 of file OgreRenderSystemCapabilitiesSerializer.h.

typedef std::map<String, Capabilities> Ogre::RenderSystemCapabilitiesSerializer::CapabilitiesMap`[protected]`

Definition at line 92 of file OgreRenderSystemCapabilitiesSerializer.h.

typedef std::vector<std::pair<String, int> > Ogre::RenderSystemCapabilitiesSerializer::CapabilitiesLinesList`[protected]`

Definition at line 102 of file OgreRenderSystemCapabilitiesSerializer.h.

## Member Enumeration Documentation

enum Ogre::RenderSystemCapabilitiesSerializer::CapabilityKeywordType`[protected]`

Enumerator:

  UNDEFINED_CAPABILITY_TYPE |
  SET_STRING_METHOD |
  SET_INT_METHOD |
  SET_BOOL_METHOD |
  SET_REAL_METHOD |
  SET_CAPABILITY_ENUM_BOOL |
  ADD_SHADER_PROFILE_STRING |

Definition at line 63 of file OgreRenderSystemCapabilitiesSerializer.h.

enum Ogre::RenderSystemCapabilitiesSerializer::ParseAction`[protected]`

Enumerator:

  PARSE_HEADER |
  FIND_OPEN_BRACE |
  COLLECT_LINES |

Definition at line 104 of file OgreRenderSystemCapabilitiesSerializer.h.

## Constructor & Destructor Documentation

Ogre::RenderSystemCapabilitiesSerializer::RenderSystemCapabilitiesSerializer | ( |  | ) |

default constructor

virtual Ogre::RenderSystemCapabilitiesSerializer::~RenderSystemCapabilitiesSerializer | ( |  | ) | `[virtual]`

default destructor

Definition at line 50 of file OgreRenderSystemCapabilitiesSerializer.h.

## Member Function Documentation

void Ogre::RenderSystemCapabilitiesSerializer::writeScript | ( | const RenderSystemCapabilities * | caps,
|  | String | name,
|  | String | filename |
| ) |  |  |

Writes a RenderSystemCapabilities object to a data stream.

void Ogre::RenderSystemCapabilitiesSerializer::parseScript | ( | DataStreamPtr & | stream | ) |

Parses a RenderSystemCapabilities script file passed as a stream.

Adds it to RenderSystemCapabilitiesManager::_addRenderSystemCapabilities

void Ogre::RenderSystemCapabilitiesSerializer::addCapabilitiesMapping | ( | String | name,
|  | Capabilities | cap |
| ) |  |  | `[protected]`

Definition at line 95 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::addKeywordType | ( | String | keyword,
|  | CapabilityKeywordType | type |
| ) |  |  | `[protected]`

Definition at line 112 of file OgreRenderSystemCapabilitiesSerializer.h.

CapabilityKeywordType Ogre::RenderSystemCapabilitiesSerializer::getKeywordType | ( | const String & | keyword | ) | const`[protected]`

Definition at line 117 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::addSetStringMethod | ( | String | keyword,
|  | SetStringMethod | method |
| ) |  |  | `[protected]`

Definition at line 129 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::callSetStringMethod | ( | String & | keyword,
|  | String & | val |
| ) |  |  | `[protected]`

Definition at line 134 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::addSetIntMethod | ( | String | keyword,
|  | SetIntMethod | method |
| ) |  |  | `[protected]`

Definition at line 149 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::callSetIntMethod | ( | String & | keyword,
|  | int | val |
| ) |  |  | `[protected]`

Definition at line 154 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::addSetBoolMethod | ( | String | keyword,
|  | SetBoolMethod | method |
| ) |  |  | `[protected]`

Definition at line 169 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::callSetBoolMethod | ( | String & | keyword,
|  | bool | val |
| ) |  |  | `[protected]`

Definition at line 174 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::addSetRealMethod | ( | String | keyword,
|  | SetRealMethod | method |
| ) |  |  | `[protected]`

Definition at line 189 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::callSetRealMethod | ( | String & | keyword,
|  | Real | val |
| ) |  |  | `[protected]`

Definition at line 194 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::addShaderProfile | ( | String & | val | ) | `[protected]`

Definition at line 208 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::setCapabilityEnumBool | ( | String & | name,
|  | bool | val |
| ) |  |  | `[protected]`

Definition at line 213 of file OgreRenderSystemCapabilitiesSerializer.h.

void Ogre::RenderSystemCapabilitiesSerializer::initialiaseDispatchTables | ( |  | ) | `[protected]`

void Ogre::RenderSystemCapabilitiesSerializer::parseCapabilitiesLines | ( | CapabilitiesLinesList & | linesList | ) | `[protected]`

void Ogre::RenderSystemCapabilitiesSerializer::logParseError | ( | const String & | error | ) | const`[protected]`

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

KeywordTypeMap Ogre::RenderSystemCapabilitiesSerializer::mKeywordTypeMap`[protected]`

Definition at line 70 of file OgreRenderSystemCapabilitiesSerializer.h.

SetStringMethodDispatchTable Ogre::RenderSystemCapabilitiesSerializer::mSetStringMethodDispatchTable`[protected]`

Definition at line 75 of file OgreRenderSystemCapabilitiesSerializer.h.

SetIntMethodDispatchTable Ogre::RenderSystemCapabilitiesSerializer::mSetIntMethodDispatchTable`[protected]`

Definition at line 80 of file OgreRenderSystemCapabilitiesSerializer.h.

SetBoolMethodDispatchTable Ogre::RenderSystemCapabilitiesSerializer::mSetBoolMethodDispatchTable`[protected]`

Definition at line 85 of file OgreRenderSystemCapabilitiesSerializer.h.

SetRealMethodDispatchTable Ogre::RenderSystemCapabilitiesSerializer::mSetRealMethodDispatchTable`[protected]`

Definition at line 90 of file OgreRenderSystemCapabilitiesSerializer.h.

CapabilitiesMap Ogre::RenderSystemCapabilitiesSerializer::mCapabilitiesMap`[protected]`

Definition at line 93 of file OgreRenderSystemCapabilitiesSerializer.h.

int Ogre::RenderSystemCapabilitiesSerializer::mCurrentLineNumber`[protected]`

Definition at line 106 of file OgreRenderSystemCapabilitiesSerializer.h.

String* Ogre::RenderSystemCapabilitiesSerializer::mCurrentLine`[protected]`

Definition at line 107 of file OgreRenderSystemCapabilitiesSerializer.h.

DataStreamPtr Ogre::RenderSystemCapabilitiesSerializer::mCurrentStream`[protected]`

Definition at line 108 of file OgreRenderSystemCapabilitiesSerializer.h.

RenderSystemCapabilities* Ogre::RenderSystemCapabilitiesSerializer::mCurrentCapabilities`[protected]`

Definition at line 110 of file OgreRenderSystemCapabilitiesSerializer.h.

The documentation for this class was generated from the following file:

- OgreRenderSystemCapabilitiesSerializer.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:35:29 2009